<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
	<modelVersion>4.0.0</modelVersion>
	<!-- FIXME - set group id -->
	<groupId>no.uib.ii.inf112</groupId>
	<!-- FIXME - set artifact name -->
	<artifactId>gdx-app</artifactId>
	<version>1.0-SNAPSHOT</version>
	<packaging>jar</packaging>
	<!-- FIXME - set app name -->
	<name>gdx-app</name>
	<!-- FIXME change it to the project's website -->
	<url>http://www.example.com</url>
	<properties>
		<project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
		<maven.compiler.release>17</maven.compiler.release>
		<libgdx.version>1.11.0</libgdx.version>
		<junit.jupiter.version>5.9.2</junit.jupiter.version>
		<slf4j.version>2.0.6</slf4j.version>
		<!-- FIXME - set to app's main class' -->
		<main.class>inf112.skeleton.app.Main</main.class>
		<jvm.extra.args></jvm.extra.args>
	</properties>
	<repositories>
		<!-- SNAPSHOT repo for Mac version -->
		<repository>
			<id>sonatype-snapshots</id>
			<url>https://oss.sonatype.org/content/repositories/snapshots</url>
			<releases>
				<enabled>false</enabled>
			</releases>
			<snapshots>
				<enabled>true</enabled>
			</snapshots>
		</repository>
	</repositories>
	<profiles>
		<!-- Fix for Mac startup issue -->
		<profile>
			<id>inf112-macosx</id>
			<!--  Maybe not needed anymore?
			<properties>
				<jvm.extra.args>-XstartOnFirstThread</jvm.extra.args>
			</properties>
			<build>
				<plugins>
					<plugin>
						<groupId>org.codehaus.mojo</groupId>
						<artifactId>exec-maven-plugin</artifactId>
						<configuration>
							<executable>${java.home}/bin/java</executable>
							<arguments>
								<argument>${jvm.extra.args}</argument>
								<argument>-classpath</argument>
								<classpath />
								<argument>${main.class}</argument>
							</arguments>
						</configuration>
					</plugin>
				</plugins>
			</build>
			-->
			<activation>
				<os>
					<family>mac</family>
				</os>
			</activation>
			<dependencies>
				<!--Should make libgdx work on Mac without -XstartOnFirstThread -->
				<dependency>
					<groupId>com.badlogicgames.gdx</groupId>
					<artifactId>gdx-lwjgl3-glfw-awt-macos</artifactId>
					<version>${libgdx.version}</version>
				</dependency>
			</dependencies>
		</profile>
		<!-- We might need the SNAPSHOT version of libgdx in order to support the M1 processor
		<profile>
			<id>inf112-macosx-aarch64</id>
			<properties>
				<libgdx.version>${libgdx.version}-SNAPSHOT</libgdx.version>
			</properties>
			<activation>
				<os>
					<family>mac</family>
					<arch>aarch64</arch>
				</os>
			</activation>
		</profile>
		 -->
	</profiles>
	<dependencies>
		<!--libGDX graphics library – https://libgdx.com/ -->
		<dependency>
			<groupId>com.badlogicgames.gdx</groupId>
			<artifactId>gdx</artifactId>
			<version>${libgdx.version}</version>
		</dependency>
		<!-- Platform-specific libraries -->
		<dependency>
			<groupId>com.badlogicgames.gdx</groupId>
			<artifactId>gdx-platform</artifactId>
			<version>${libgdx.version}</version>
			<classifier>natives-desktop</classifier>
		</dependency>
		<dependency>
			<groupId>com.badlogicgames.gdx</groupId>
			<artifactId>gdx-backend-lwjgl3</artifactId>
			<version>${libgdx.version}</version>
		</dependency>
		<dependency>
			<groupId>org.junit.jupiter</groupId>
			<artifactId>junit-jupiter</artifactId>
			<version>${junit.jupiter.version}</version>
			<scope>test</scope>
		</dependency>
		<dependency>
			<groupId>org.slf4j</groupId>
			<artifactId>slf4j-api</artifactId>
			<version>${slf4j.version}</version>
		</dependency>
		<dependency>
			<groupId>org.slf4j</groupId>
			<artifactId>slf4j-simple</artifactId>
			<version>${slf4j.version}</version>
		</dependency>
			</dependencies>
	<build>
		<plugins>
			<!-- Run app through Maven -->
			<plugin>
				<groupId>org.codehaus.mojo</groupId>
				<artifactId>exec-maven-plugin</artifactId>
				<configuration>
					<mainClass>${main.class}</mainClass>
					<arguments></arguments>
				</configuration>
			</plugin>
			<!-- Build a fat uber-jar with all dependencies -->
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-shade-plugin</artifactId>
				<version>3.3.0</version>
				<executions>
					<execution>
						<phase>package</phase>
						<goals>
							<goal>shade</goal>
						</goals>
						<configuration>
							<transformers>
								<transformer implementation="org.apache.maven.plugins.shade.resource.ManifestResourceTransformer">
									<manifestEntries>
										<Main-Class>${main.class}</Main-Class>
									</manifestEntries>
								</transformer>
								<transformer implementation="org.apache.maven.plugins.shade.resource.ServicesResourceTransformer" />
							</transformers>
							<artifactSet></artifactSet>
							<outputFile>${project.build.directory}/${project.artifactId}-${project.version}-fat.jar</outputFile>
						</configuration>
					</execution>
				</executions>
			</plugin>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-enforcer-plugin</artifactId>
				<version>3.2.1</version>
				<executions>
					<execution>
						<id>enforce-maven</id>
						<goals>
							<goal>enforce</goal>
						</goals>
						<configuration>
							<rules>
								<requireMavenVersion>
									<version>3.3.1</version>
								</requireMavenVersion>
							</rules>
						</configuration>
					</execution>
				</executions>
			</plugin>
			<plugin>
				<groupId>org.jacoco</groupId>
				<artifactId>jacoco-maven-plugin</artifactId>
				<version>0.8.8</version>
				<executions>
					<execution>
						<id>default-prepare-agent</id>
						<goals>
							<goal>prepare-agent</goal>
						</goals>
					</execution>
					<execution>
						<id>default-report</id>
						<phase>test</phase>
						<goals>
							<goal>report</goal>
						</goals>
					</execution>
				</executions>
			</plugin>
		</plugins>
		<pluginManagement>
			<!-- lock down plugins versions to avoid using Maven defaults (may be moved to parent pom) -->
			<plugins>
				<plugin>
					<artifactId>maven-clean-plugin</artifactId>
					<version>3.1.0</version>
				</plugin>
				<plugin>
					<artifactId>maven-site-plugin</artifactId>
					<version>3.11.0</version>
				</plugin>
				<plugin>
					<artifactId>maven-project-info-reports-plugin</artifactId>
					<version>3.2.2</version>
				</plugin>
				<plugin>
					<artifactId>maven-resources-plugin</artifactId>
					<version>3.2.0</version>
				</plugin>
				<plugin>
					<artifactId>maven-compiler-plugin</artifactId>
					<version>3.10.1</version>
				</plugin>
				<plugin>
					<artifactId>maven-surefire-plugin</artifactId>
					<version>3.0.0-M5</version>
					<configuration>
						<useModulePath>false</useModulePath>
						<argLine></argLine>
					</configuration>
				</plugin>
				<plugin>
					<artifactId>maven-jar-plugin</artifactId>
					<version>3.2.2</version>
				</plugin>
				<plugin>
					<artifactId>maven-install-plugin</artifactId>
					<version>3.0.0-M1</version>
				</plugin>
				<plugin>
					<artifactId>maven-deploy-plugin</artifactId>
					<version>3.0.0-M2</version>
				</plugin>
				<plugin>
					<groupId>org.codehaus.mojo</groupId>
					<artifactId>exec-maven-plugin</artifactId>
					<version>3.0.0</version>
				</plugin>
			</plugins>
		</pluginManagement>
	</build>
</project>
